      //
      //  Retrieve job's IP address
      //
      //  Programmer's notes:
      //    Earliest release program will run: V5R1
      //    Only returns the first IP address found
      //     (should be OK for non-system jobs)
      //
      //  Compile options:
      //
      //    CrtRpgMod Module(RTVIPADDRR)  DbgView( *LIST )
      //
      //    CrtPgm    Pgm(RTVIPADDRR)
      //              Module(RTVIPADDRR)
      //              Bndsrvpgm(QTOCNETSTS)
      //
      //-- Header specifications:  --------------------------------------------**
     H Option( *SrcStmt : *NoDebugIO)
      //-- System information:  -----------------------------------------------**
     D                SDs
     D  PsPgmNam         *Proc
      //-- Global declarations:  ----------------------------------------------**
     D Lix             s             10u 0
     D Dix             s             10u 0
     D BytAlc          s             10u 0
     D UsrSpc          c                   'RTVIPADDR QTEMP    '
      //
     D Time            s              6s 0
     D NbrRcds         s             10u 0
     D TcpCnnStt       s              4a
     D ConOpnTyp       s              3a
      //-- Api error data structure:  -----------------------------------------**
     D ApiError        Ds
     D  AeBytPro                     10i 0 Inz( %Size( ApiError ))
     D  AeBytAvl                     10i 0 Inz
     D  AeMsgId                       7a
     D                                1a
     D  AeMsgDta                    128a
      //
      //-- API Header information:  -------------------------------------------**
     D HdrInf          Ds                  Based( pHdrInf )
     D  HiUsrSpcNamSp                10a
     D  HiUsrSpcLibSp                10a
      //-- User space generic header:  ---------- -----------------------------**
     D UsrSpcHdr       Ds                  Based( pUsrSpc )
     D  UsOfsHdr                     10i 0 Overlay( UsrSpcHdr: 117 )
     D  UsOfsLst                     10i 0 Overlay( UsrSpcHdr: 125 )
     D  UsNumLstEnt                  10i 0 Overlay( UsrSpcHdr: 133 )
     D  UsSizLstEnt                  10i 0 Overlay( UsrSpcHdr: 137 )
      //-- User space pointers:  ----------------------------------------------**
     D pUsrSpc         s               *   Inz( *Null )
     D pHdrInf         s               *   Inz( *Null )
     D pLstEnt         s               *   Inz( *Null )
      //-- TCP/IP attributes:  ------------------------------------------------**
     D TCPA0100        Ds
     D  T1BytRtn                     10u 0
     D  T1BytAvl                     10u 0
     D  T1StkSts                     10u 0
     D  T1ActTim                     10u 0
     D  T1LstStrD                     8a
     D  T1LstStrT                     6a
     D  T1LstEndD                     8a
     D  T1LstEndT                     6a
     D  T1StrJob                     10a
     D  T1StrUsr                     10a
     D  T1StrNbr                      6a
     D  T1StrJobInt                  16a
     D  T1EndJob                     10a
     D  T1EndUsr                     10a
     D  T1EndNbr                      6a
     D  T1EndJobInt                  16a
     D  T1OfsAddInf                  10u 0
     D  T1LenAddInf                  10u 0
      //-- Connection list qualifier:  ----------------------------------------**
     D NCLQ0100        Ds
     D  N1NetCnnTyp                  10a   Inz( '*ALL' )
     D  N1LstRqsTyp                  10a   Inz( '*ALL' )
     D                               12a   Inz( *Allx'00' )
     D  N1LocAdrLow                  10u 0 Inz( 0 )
     D  N1LocAdrUpr                  10u 0 Inz( 0 )
     D  N1LocPortLow                 10u 0 Inz( 0 )
     D  N1LocPortUpr                 10u 0 Inz( 0 )
     D  N1RmtAdrLow                  10u 0 Inz( 0 )
     D  N1RmtAdrUpr                  10u 0 Inz( 0 )
     D  N1RmtPortLow                 10u 0 Inz( 0 )
     D  N1RmmPortUpr                 10u 0 Inz( 0 )
      //-- Connection list entry:  --------------------------------------------**
     D NCNN0100        Ds                  Based( pLstEnt )
     D  C1RmtAdr                     15a
     D                                1a
     D  C1RmtAdrBin                  10u 0
     D  C1LocAdr                     15a
     D                                1a
     D  C1LocAdrBin                  10u 0
     D  C1RmtPort                    10u 0
     D  C1LocPort                    10u 0
     D  C1TcpState                   10u 0
     D  C1IdlTimMs                   10u 0
     D  C1BytIn                      20u 0
     D  C1BytOut                     20u 0
     D  C1ConOpnTyp                  10u 0
     D  C1NetCnnTyp                  10a
     D                                1a
      //-- Socket connection request:  ----------------------------------------**
     D SocCnnRqs       Ds
     D  ScProtocol                   10u 0
     D  ScLocIpAdr                   10u 0
     D  ScLocPortNbr                 10u 0
     D  ScRmtIpAdr                   10u 0
     D  ScRmtPortNbr                 10u 0
      //-- Connection data:  --------------------------------------------------**
     D NCND0100        Ds                  Based( pCnnDta )
     D  D1BytRtn                     10u 0
     D  D1BytAvl                     10u 0
     D  D1CurCnnEst                  10u 0
     D  D1ActOpn                     10u 0
     D  D1PasOpn                     10u 0
     D  D1AttOpnFail                 10u 0
     D  D1EstNxtRes                  10u 0
     D  D1SegSnt                     10u 0
     D  D1SegRtr                     10u 0
     D  D1SegRsn                     10u 0
     D  D1SegRcv                     10u 0
     D  D1SegRcvErr                  10u 0
     D  D1DtgSnt                     10u 0
     D  D1DtgRcv                     10u 0
     D  D1DtgNdlPort                 10u 0
     D  D1DtgNdlOde                  10u 0
     D  D1AddInfOfs                  10u 0
     D  D1AddInfLen                  10u 0
      //
     D NCND0200        Ds                  Based( pCnnDtaInf )
     D  D2Protocol                   10u 0
     D  D2LocIpAdr                   10u 0
     D  D2LocPortNbr                 10u 0
     D  D2RmtIpAdr                   10u 0
     D  D2RmtPortNbr                 10u 0
     D  D2RndTrpTim                  10u 0
     D  D2RndTrpVar                  10u 0
     D  D2OutBytBuf                  10u 0
     D  D2UsrSndNxt                  10u 0
     D  D2SndNxt                     10u 0
     D  D2SndUnack                   10u 0
     D  D2OutPshNbr                  10u 0
     D  D2OutUrgNbr                  10u 0
     D  D2OutWdwNbr                  10u 0
     D  D2IncBytBuf                  10u 0
     D  D2RcvNxt                     10u 0
     D  D2UsrRcvNxt                  10u 0
     D  D2IncPshNbr                  10u 0
     D  D2IncUrgNbr                  10u 0
     D  D2IncWdwNbr                  10u 0
     D  D2TotRtr                     10u 0
     D  D2CurRtr                     10u 0
     D  D2MaxWdwSiz                  10u 0
     D  D2CurWdwSiz                  10u 0
     D  D2LastUpd                    10u 0
     D  D2LastUpdAck                 10u 0
     D  D2CngWdw                     10u 0
     D  D2SlwStrThr                  10u 0
     D  D2MaxSegSiz                  10u 0
     D  D2InzSndSeqNb                10u 0
     D  D2InzRcvSeqNb                10u 0
     D  D2CnnTspLayer                10u 0
     D  D2TcpState                   10u 0
     D  D2CnnOpnTyp                  10u 0
     D  D2IdlTimMs                   10u 0
     D  D2IpOpt                      40a
     D  D2BytIn                      10u 0
     D  D2BytOut                     10u 0
     D  D2SocState                   10u 0
     D  D2SocLstOfs                  10u 0
     D  D2SocEntNbr                  10u 0
     D  D2SocEntLen                  10u 0
     D  D2JobLstOfs                  10u 0
     D  D2JobEntNbr                  10u 0
     D  D2JobEntLen                  10u 0
      //-- Socket options list:
     D SocOptLst       Ds                  Based( pSocOptLst )
     D  SoSocOpt                     10u 0
     D  SoOptVal                     10u 0
      //-- Associated jobs/tasks list:
     D JobCnnLst       Ds                  Based( pJobCnnLst )
     D  JcFmtEnt                     10u 0
     D  JcTskNam                     16a
     D  JcJobNam                     10a
     D  JcJobUsr                     10a
     D  JcJobNbr                      6a
     D  JcJobId                      16a
      //*****************************************************************
      //Record structure for QUSRJOBI JOBI0400 format
      //*****************************************************************
     DQUSI0400         DS
      //                                             Qwc JOBI0400
     D QUSBR03                 1      4i 0
      //                                             Bytes Return
     D QUSBA03                 5      8i 0
      //                                             Bytes Avail
     D QUSJN06                 9     18
      //                                             Job Name
     D QUSUN05                19     28
      //                                             User Name
     D QUSJNBR05              29     34
      //                                             Job Number
      //-- Create user space: -------------------------------------------------**
     D CrtUsrSpc       Pr                  ExtPgm( 'QUSCRTUS' )
     D  CsSpcNamQ                    20a   Const
     D  CsExtAtr                     10a   Const
     D  CsInzSiz                     10i 0 Const
     D  CsInzVal                      1a   Const
     D  CsPubAut                     10a   Const
     D  CsText                       50a   Const
      //-- Optional 1:
     D  CsReplace                    10a   Const Options( *NoPass )
     D  CsError                   32767a         Options( *NoPass: *VarSize )
      //-- Optional 2:
     D  CsDomain                     10a   Const Options( *NoPass )
      //-- Delete user space: -------------------------------------------------**
     D DltUsrSpc       Pr                  ExtPgm( 'QUSDLTUS' )
     D  DsSpcNamQ                    20a   Const
     D  DsError                   32767a         Options( *VarSize )
      //-- Retrieve pointer to user space: ------------------------------------**
     D RtvPtrSpc       Pr                  ExtPgm( 'QUSPTRUS' )
     D  RpSpcNamQ                    20a   Const
     D  RpPointer                      *
     D  RpError                   32767a         Options( *NoPass: *VarSize )
      //-- Retrieve TCP/IP attributes:  ---------------------------------------**
     D RtvTcpA         Pr                  ExtProc( 'QtocRtvTCPA' )
     D  RtRcvVar                  32767a          Options( *VarSize )
     D  RtRcvVarLen                  10i 0 Const
     D  RtFmtNam                      8a   Const
     D  RtError                   32767a          Options( *VarSize )
      //-- List network connections:  -----------------------------------------**
     D LstNetCnn       Pr                  ExtProc( 'QtocLstNetCnn' )
     D  LcSpcNamQ                    20a   Const
     D  LcFmtNam                      8a   Const
     D  LcCnnQual                    64a   Const
     D  LcCnnQualSiz                 10i 0 Const
     D  LcCnnQualFmt                  8a   Const
     D  LcError                   32767a         Options( *VarSize )
      //-- Retrieve network connection data:  ---------------------------------**
     D RtvCnnDta       Pr                  ExtProc( 'QtocRtvNetCnnDta' )
     D  RcRcvVar                  65535a         Options( *VarSize )
     D  RcRcvVarLen                  10i 0 Const
     D  RcFmtNam                      8a   Const
     D  RcSocCnnRqs                  20a   Const
     D  RcError                   32767a         Options( *VarSize )
      //-- Send Message: ------------------------------------------------------**
      //*-- Retrieve Job Information: ------------------------------------------**
     d RtvJobI         PR                  ExtPgm('QUSRJOBI')                   Retrieve Job Info
     d                            32767    Options(*varsize)                    Information Retrieve
     d                               10i 0 const                                Length of Info
     d                                8    const                                Requested format
     d                               26    const                                Qualified Job Name
     d                               16    const                                Internal Job ID
     db                                    like(vApiErrDS)
      //*************************************************************************
      // Data structures & fields
      //*************************************************************************
      //
     d vApiErrDs       ds
     d  vbytpv                       10i 0 inz(%len(vApiErrDs))                 bytes provided
     d  vbytav                       10i 0 inz(0)                               bytes returned
     d  vmsgid                        7a                                        error msgid
     d  vresvd                        1a                                        reserved
     d  vrpldta                     128a                                        replacement data
      //
     d AddressFound    s               n   inz(*off)
      //-- Program protype & interface: ---------------------------------------**
     d RtvIPAddrr      pr
     d  FullJob                      26a
     d  IPAddress                    15a
      *
     d RtvIPAddrr      pi
     d  FullJob                      26a
     d  IPAddress                    15a

      //-- Mainline:  ---------------------------------------------------------**
      //
      /FREE
       Reset vApiErrDs;
       RtvJobI(QUSI0400:
               %len(qusi0400):
               'JOBI0400':
               FullJob:
               ' ':
               vApiErrDs);
       //
       RtvTcpA(TCPA0100:
               %Size(TCPA0100):
               'TCPA0100':
               ApiError);
       //
       Select;
       When AeBytAvl > *Zero;
         //-- Error occurred...
         //
       When T1StkSts = 0 Or
            T1StkSts = 2;
         //-- TCP/IP stack not operational...
         //
       Other;
          BytAlc = 32767;
          pCnnDta = %Alloc(BytAlc);
          //
          CrtUsrSpc(UsrSpc:
                    *Blanks:
                    65535:
                    x'00':
                    '*CHANGE':
                    *Blanks:
                    '*YES':
                    ApiError);
          //
          LstNetCnn(UsrSpc:
                    'NCNN0100':
                    NCLQ0100:
                    %Size(NCLQ0100):
                    'NCLQ0100':
                    ApiError);
          //
          ExSr PrcLstEnt;
          //
          DltUsrSpc(UsrSpc:
                    ApiError);
          //
          DeAlloc pCnnDta;
          //
       EndSl;
       //
       *InLr = *On;
       Return;
       //
       //-- Process list entries:  ---------------------------------------------**
       BegSr PrcLstEnt;
          //
          RtvPtrSpc(UsrSpc:
                    pUsrSpc);
          //
          pHdrInf = pUsrSpc + UsOfsHdr;
          pLstEnt = pUsrSpc + UsOfsLst;
          //
          For Lix = 1 to UsNumLstEnt;
             //
             Select;
             When C1NetCnnTyp = '*TCP';
                ScProtocol  = 1;
                //
             When C1NetCnnTyp = '*UDP';
                ScProtocol  = 2;
                //
             Other;
                ScProtocol  = 0;

             EndSl;

             If ScProtocol  > 0;
                //
                ScLocIpAdr = C1LocAdrBin;
                ScLocPortNbr = C1LocPort;
                ScRmtIpAdr = C1RmtAdrBin;
                ScRmtPortNbr = C1RmtPort;
                //
                DoU D1BytAvl <= BytAlc;
                //
                If D1BytAvl > BytAlc;
                   BytAlc = D1BytAvl;
                   pCnnDta = %ReAlloc(pCnnDta:
                                      BytAlc);
                EndIf;
                //
                RtvCnnDta(NCND0100:
                          BytAlc:
                          'NCND0200':
                          SocCnnRqs:
                          ApiError);
              EndDo;
              //
              If AeBytAvl = *Zero;
                 Exsr PrcDtaEnt;
                 If AddressFound;
                    Leave;
                 Endif;
              EndIf;
           EndIf;
           //
           If Lix < UsNumLstEnt;
              pLstEnt = pLstEnt + UsSizLstEnt;
           EndIf;
        EndFor;
          //
        EndSr;
        //-- Process data list entries:  ----------------------------------------**
        BegSr PrcDtaEnt;
           //
           pCnnDtaInf = pCnnDta + D1AddInfOfs;
           //
           //-- Socket options:
           pSocOptLst = pCnnDta + D2SocLstOfs;
           For Dix = 1 to D2SocEntNbr;
              //
              //--
              If Dix < D2SocEntNbr;
                 pSocOptLst = pSocOptLst + D2SocEntLen;
              EndIf;
           EndFor;
           //
           //-- Associated jobs:
           pJobCnnLst  = pCnnDta + D2JobLstOfs;
           //
           For Dix = 1 to D2JobEntNbr;
              //
              If JcFmtEnt = 1;
                 If jcjobnbr = qusjnbr05;
                    IpAddress = %trim(%xlate(x'00':' ':C1RmtAdr));
                    AddressFound = *on;
                    Leave;
                 Endif;
              EndIf;
              //
              If Dix < D2JobEntNbr;
                 pJobCnnLst  = pJobCnnLst + D2JobEntLen;
              EndIf;
           EndFor;
           //
        EndSr;

      /END-FREE
